<?php
/*
Plugin Name: SRG Clean Archives WP2.3
Plugin URI: http://www.viewfinderdesign.co.uk/archive/category/downloads/
Description: A nice uniform way to display your archives. Based on code by Shawn Grims, which was based on code originally written by <a href="http://www.kingcosmonaut.de/">Sebastian Schmieg.</a>
Version: 1.6
Author: Lee Penney, based on work by Shawn Grimes, Sebastian Schmieg.
Author URI: http://www.thedigeratipeninsula.org.uk/

I just updated this to work with version 2.3 of WordPress as it appears Shawn is no longer maintaining it (at least, not at the URL in this plugin).
*/

function srg_clean_archives($exclude_cat = 0)
{
    global $month, $wpdb;
    $now = current_time('mysql');
    $arcresults = $wpdb->get_results("SELECT DISTINCT YEAR(post_date) AS year, MONTH(post_date) AS month, count(ID) as posts FROM " . $wpdb->posts . " WHERE post_date <'" . $now . "' AND post_status='publish' AND post_password='' GROUP BY YEAR(post_date), MONTH(post_date) ORDER BY post_date DESC");

    if ($arcresults) {
		  $c = 0;
        foreach ($arcresults as $arcresult) {
				    if ($c % 2) {
							$clear = 1;
						} else {
							$clear = 0;
						}
						$c++;
				
            $url  = get_month_link($arcresult->year, $arcresult->month);
            $text = sprintf('%s %d', $month[zeroise($arcresult->month,2)], $arcresult->year);

            $thismonth   = zeroise($arcresult->month,2);
            $thisyear = $arcresult->year;
            
            /*$arcresults2 = $wpdb->get_results("SELECT ID, post_date, post_title, comment_status FROM " . $wpdb->posts . " WHERE post_date LIKE '$thisyear-$thismonth-%' AND post_date AND post_status='publish' AND post_password='' ORDER BY post_date DESC");*/

			//$wpdb->categories replaced by $wpdb->terms
			//$wpdb->post2cat replaced by $wpdb->term_relationships
			//$wpdb->post2cat.post_id replaced by $wpdb->term_relationships.object_id
			//$wpdb->post2cat.category_id replaced by $wpdb->term_relationships.term_taxonomy_id
			//$wpdb->categories.cat_ID replaced by $wpdb->terms.term_id
			
            $arcresults2 = $wpdb->get_results("SELECT DISTINCT ID, post_title, post_date, comment_status FROM ".$wpdb->posts.", ".$wpdb->terms.",". $wpdb->term_relationships." WHERE ".$wpdb->posts.".post_date LIKE '$thisyear-$thismonth-%' AND ".$wpdb->posts.".post_date AND ".$wpdb->posts.".post_status = 'publish' AND ".$wpdb->term_relationships.".object_id = ".$wpdb->posts.".ID AND ".$wpdb->terms.".term_id = ".$wpdb->term_relationships.".term_taxonomy_id AND ".$wpdb->terms.".term_id != '$exclude_cat' AND post_password='' ORDER BY post_date DESC");

            if ($arcresults2) {
                echo "<ul class=\"postspermonth\">\n";
								echo get_archives_link($url, $text, '','<h3>','</h3>');
								echo "<li class=\"linktop\"><a href=\"#content\" title=\"link to top of page\">top</a></li>\n";
								
                foreach ($arcresults2 as $arcresult2) {
								        if ($arcresult2->post_date != '0000-00-00 00:00:00') {
                         $url       = get_permalink($arcresult2->ID);
                         $arc_title = $arcresult2->post_title;

                         if ($arc_title) $text = strip_tags($arc_title);
                        else $text = $arcresult2->ID;
                        $title_text = wp_specialchars($text, 1);

                          echo '<li><span>' . mysql2date('jS', $arcresult2->post_date). '</span> ' . "<a href='$url' title='$title_text'>$text</a>";
                        /*$comments_count = $wpdb->get_var("SELECT COUNT(comment_id) FROM " . $wpdb->comments . " WHERE comment_post_ID=" . $arcresult2->ID);
                        if ($arcresult2->comment_status == "open" OR $comments_count > 0) echo ' (' . $comments_count . ')';*/
                        echo '</li>';
                     }
                }
                echo "</ul>\n";
								if ($clear == 1) {
								  echo "<div class=\"clear\"></div>\n";
								}
            }
        }
    }
}
?>